// Copyright (C) 2022 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:http/http.dart';
import 'package:wyatt_http_client/src/utils/protocols.dart';
import 'package:wyatt_http_client/src/utils/utils.dart';

class RestClient extends BaseClient {
  final Protocols protocol;
  final String? authority;

  final Client _inner;

  RestClient({
    this.protocol = Protocols.https,
    this.authority = '',
    Client? inner,
  }) : _inner = inner ?? Client();

  @override
  Future<StreamedResponse> send(BaseRequest request) {
    final Uri uri = Uri.parse('${protocol.scheme}$authority${request.url}');
    return _inner.send(Utils.copyRequestWith(request, url: uri));
  }
}
